#ifndef CGUL_BLOCK_READER_FILE_P_H
#define CGUL_BLOCK_READER_FILE_P_H

#include "cgul_block_reader_file.h"
#include "cgul_block_reader_p.h"

CGUL_BEGIN_C

/** Data encapsulated by the <code>cgul_block_reader_file</code> class. */
struct cgul_block_reader_file {

    /**
     * Inherit from the <code>cgul_block_reader</code> base class.
     */
    struct cgul_block_reader super;

    /**
     * The underlying file from which blocks are read.
     */
    FILE* f;

    /**
     * Boolean that describes whether this class owns <code>f</code>.
     * If and only if this class owns <code>f</code>, will it be
     * closed when the object is deleted.
     */
    int we_own_f;

    /**
     * Name of the currently opened file.  If a <code>FILE*</code> was
     * passed in instead of a file name, <code>"FILE"</code> will be
     * used.
     */
    char* fname;

    /**
     * Presentation name.  This is the name used in error messages.
     * If the object is initialized by a call to
     * <code>cgul_block_reader_file__open_fname()</code>, the
     * presentation name defaults to the file name.
     */
    char* presentation_name;

};

CGUL_END_C

#endif  /*  CGUL_BLOCK_READER_FILE_P_H  */
