#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 0;
    cgul_exception_t local = NULL;
    cgul_big_integer_t a = NULL;
    cgul_big_integer_t x = NULL;

    a = cgul_big_integer__new_from_string(&local, "0");
    x = cgul_big_integer__new_from_string(&local, "99999999999999999999999999999999999999999999999999999999999999999999999999999999");

    {
        cgul_big_integer_t quotient =
            cgul_big_integer__new_from_string(&local, "0");
        cgul_big_integer_t remainder =
            cgul_big_integer__new_from_string(&local, "0");
        cgul_big_integer_t dividend =
            cgul_big_integer__new_from_string(&local, "81000001");
        cgul_big_integer_t divisor =
            cgul_big_integer__new_from_string(&local, "0x999");

        /* Print the dividend and the divisor. */
        cgul_libc__printf(&local, "%12s = ", "dividend");
        cgul_big_integer__print_as_decimal(&local, dividend, stdout);
        puts("");
        cgul_libc__printf(&local, "%12s = ", "divisor");
        cgul_big_integer__print_as_decimal(&local, divisor, stdout);
        puts("");

        /* Divide */
        cgul_big_integer__divide(&local, quotient, remainder, dividend, divisor);

        /* Print quotient and remainder. */
        cgul_libc__printf(&local, "%12s = ", "quotient");
        cgul_big_integer__print_as_decimal(&local, quotient, stdout);
        puts("");
        cgul_libc__printf(&local, "%12s = ", "remainder");
        cgul_big_integer__print_as_decimal(&local, remainder, stdout);
        puts("");

        if (divisor) {
            cgul_big_integer__delete(divisor);
        }
        if (dividend) {
            cgul_big_integer__delete(dividend);
        }
        if (remainder) {
            cgul_big_integer__delete(remainder);
        }
        if (quotient) {
            cgul_big_integer__delete(quotient);
        }
    }

#if 0
    cgul_big_integer__print_as_binary(&local, x, stdout); puts("\n");
    cgul_big_integer__print_as_octal(&local, x, stdout); puts("\n");
    cgul_big_integer__print_as_decimal(&local, x, stdout); puts("\n");
    cgul_big_integer__print_as_hexadecimal(&local, x, stdout); puts("\n");
#endif

    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    if (x) {
        cgul_big_integer__delete(x);
    }

    if (a) {
        cgul_big_integer__delete(a);
    }

    return rv;
}
