#include "cgul.h"

typedef struct {
    char** words;
    char* key;
    int index;
} main_index_compare_data, *main_index_compare_data_t;

static int
main_string_compare(const void* p1,
                    const void* p2)
{
    return strcmp((char*)p1, (char*)p2);
}

static int
main_index_compare(int index,
                   void* data)
{
    int rv = 0;
    main_index_compare_data_t d = (main_index_compare_data_t)data;

    rv = strcmp(d->key, d->words[index]);
    if (rv == 0) {
        d->index = index;
    }
    return rv;
}                   

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_exception_t local = NULL;
    char* key = "aaa";
    char* ptr = NULL;

    /* cgul_binary_search() */
    {
        char words [][4] = {
            {'a', 'a', 'a', '\0'},
            {'b', 'b', 'b', '\0'},
            {'c', 'c', 'c', '\0'},
            {'d', 'd', 'd', '\0'},
            {'e', 'e', 'e', '\0'},
            {'f', 'f', 'f', '\0'},
        };
        ptr = cgul_binary_search(&local,
                                 key,
                                 (const void*)words,
                                 sizeof(words) / sizeof(*words),
                                 sizeof(*words),
                                 main_string_compare);
        cgul_libc__printf(&local, "ptr = %s\n", ptr);
    }

    /* cgul_binary_search_pointers() */
    {
        char* words[] = {"aaa", "bbb", "ccc", "ddd", "eee", "fff"};
        ptr = cgul_binary_search_pointers(&local,
                                          key,
                                          (const void**)words,
                                          sizeof(words) / sizeof(*words),
                                          main_string_compare);
        cgul_libc__printf(&local, "ptr = %s\n", ptr);
    }

    /* cgul_binary_search_irange() */
    {
        char* words[] = {"aaa", "bbb", "ccc", "ddd", "eee", "fff"};
        main_index_compare_data data = {words, key, -1};

        ptr = NULL;
        if (cgul_binary_search_irange(&local,
                                      0,
                                      sizeof(words) / sizeof(*words),
                                      main_index_compare,
                                      &data))
            {
                ptr = words[data.index];
            }
        cgul_libc__printf(&local, "ptr = %s\n", ptr);
    }

    if (local) {
        goto out;
    }

 out:

    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    return rv;
}
