#include <unistd.h>
#include <stdio.h>
#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 0;
    unsigned short result = 0;
    size_t rcount = 0;
    cgul_crc16_t crc16 = NULL;
    cgul_exception_t cex = NULL;
    unsigned char buf[16384];

    crc16 = cgul_crc16__new(&cex, 0x8408, 0, 0, 1);
    if (cex) {
        goto out;
    }

    for (;;) {
        rcount = read(STDIN_FILENO, buf, sizeof(buf));
        if (rcount <= 0) {
            break;
        }
        cgul_crc16__update_block(&cex, crc16, buf, rcount);
    }
    result = cgul_crc16__crc(&cex, crc16);
    cgul_libc__printf(&cex, "%d  %#06hx\n", result, result);

 out:

    if (cex) {
        const char* msg = cgul_exception__get_message(cex);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(cex);
        cex = NULL;
        rv = 1;
    }

    if (crc16) {
        cgul_crc16__delete(crc16);
    }

    return rv;
}
