#include "cgul_cxx.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_int16_t   x16 = 0x0123;
    cgul_int32_t   x32 = 0x01234567;
#ifdef CGUL_INT64
    cgul_int64_t   x64 = 0x0123456789abcdef;
#endif

    /*************************************************************************
     * Detect
     *************************************************************************/

    printf("          cgul_endian_cxx::is_big_endian() = %d\n",
           cgul_endian_cxx::is_big_endian());
    printf("       cgul_endian_cxx::is_little_endian() = %d\n",
           cgul_endian_cxx::is_little_endian());
    puts("");

    /*************************************************************************
     * Swap Integers
     *************************************************************************/

    /* 16-bit signed values */
    printf("                                       x16 = 0x%04hx\n", x16);
    cgul_endian_cxx::swap((char*)&x16, sizeof(x16));
    printf("  cgul_endian_cxx::swap(&x16, sizeof(x16)) = 0x%04hx\n", x16);
    puts("");

    /* 32-bit signed values */
    printf("                                       x32 = 0x%08x\n", x32);
    cgul_endian_cxx::swap((char*)&x32, sizeof(x32));
    printf("  cgul_endian_cxx::swap(&x32, sizeof(x32)) = 0x%08x\n", x32);
    puts("");


#ifdef CGUL_INT64
    /* 64-bit signed values */
    printf("                                       x64 = 0x%016lx\n", x64);
    cgul_endian_cxx::swap((char*)&x64, sizeof(x64));
    printf("  cgul_endian_cxx::swap(&x64, sizeof(x64)) = 0x%016lx\n", x64);
    puts("");
#endif

    return rv;
}
