#include <cstdlib>
#include <stdexcept>
#include <iostream>
#include "cgul_cxx.h"

using namespace std;

static int
free_hash_keys(cgul_hash_cxx* h,
               cgul_hash_node_cxx* n,
               void* data)
{
    free((void*)n->get_key());
    return 1;
}

int main(int argc, char* argv[])
{
    int rv = 0;
    int i = 0;
    char* key = NULL;
    cgul_hash_cxx h;
    cgul_string_cxx s;
    cgul_hash_node_cxx* n = NULL;

    try {

        /* Insert keys for "0" through "99". */
        for (i = 0 ; i < 100 ; ++i) {
            s.set_value("");
            s.append_decimal(i);
            key = s.get_value();
            if (h.insert(key, NULL)) {
                s.take_value();
            } else {
                cerr << "*** Error: Unable to insert key: " << key << endl;
            }
        }

        /* Print keys forward. */
        n = h.get_oldest();
        while (n) {
            key = (char*)n->get_key();
            puts(key);
            n = n->get_younger();
        }

        cout << "=====" << endl;

        /* Print keys reverse. */
        n = h.get_youngest();
        while (n) {
            key = (char*)n->get_key();
            puts(key);
            n = n->get_older();
        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    /* Clean up. */
    h.traverse(free_hash_keys, NULL);

    return rv;
}
