#include "cgul_cxx.h"
#include <iostream>
#include <stdexcept>

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;

    try {

        cgul_microxml_cxx uxml("tmp.xml");

        /* Skip the document start token. */
        uxml.read_next_token();
        if (!uxml.is_document_start()) {
            throw cgul_exception_cxx("expected document start");
        }

        /* Iterate over the top-level MicroXML tokens.  Note that
         * there can be multiple top-level tokens if reporting prolog
         * or epilog tokens (leading or trailing white space or
         * comments) is enabled. */
        for (;;) {

            /* Read the next top-level MicroXML token. */
            uxml.read_next_token();

            /* EOF */
            if (uxml.is_document_end()) {
                break;
            }

#if 0
            /* Recursively print this top-level MicroXML token. */
            main__print_token(uxml, cout);
#endif

        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
