#include <iostream>
#include "cgul_cxx.h"

using namespace std;

int main(int argc, char* argv[])
{
    int rv = 0;
    int i = 0;
    cgul_progress_bar_cxx* bar = NULL;
    cgul_string_cxx* s = NULL;

    try {

        bar = new cgul_progress_bar_cxx;
        s = new cgul_string_cxx;

        bar->set_min(0);
        bar->set_max(10);

        /* Draw the simple bar. */
        bar->set_style(CGUL_PROGRESS_BAR__SIMPLE);
        for (i = 0 ; i <= 10 ; ++i) {
            bar->update(i);
            //sleep(1);
        }

        printf("\n");

        /* Draw a common-style bar. */
        bar->reset();
        bar->set_style(CGUL_PROGRESS_BAR__COMMON);
        for (i = 0 ; i <= 10 ; ++i) {
            *s = "";
            s->append_sprintf("%d/%d", i, 10);
            s->pad_right(5, ' ');
            bar->update(i, "before:", s->get_value());
            //sleep(1);
        }

#if 0
    /* Show that the common-style bar can run in reverse. */
        for (i = 9 ; i >= 0 ; --i) {
            *s = "";
            s->append_sprintf("%d/%d", i, 10);
            s->pad_right(5, ' ');
            bar->update(i, "before:", s->get_value());
            //sleep(1);
        }
#endif

        printf("\n");

    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    if (s) {
        delete s;
    }

    if (bar) {
        delete bar;
    }

    return rv;
}
