#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    size_t i;
    size_t v_count = 1000000;
    cgul_uint32_t* v = NULL;
    cgul_random_lfg32_t prng = NULL;
    cgul_exception_t local = NULL;

    /* Allocate. */
    v = cgul_libc__calloc(&local, v_count, sizeof(*v));
    prng = cgul_random_lfg32__new(&local);
    if (local) {
        goto out;
    }

    /* Initialize. */
    for (i = 0 ; i < v_count ; ++i) {
        v[i] = i;
        //v[i] = i - v_count / 2;
    }

    /* Shuffle. */
    cgul_shuffle_uint32(&local,
                        v,
                        v_count,
                        (cgul_shuffle__next_in_range_t)
                            cgul_random_lfg32__next_in_range,
                        prng);
    if (local) {
        goto out;
    }

#if 0
    /* Print the shuffled array. */
    for (i = 0 ; i < v_count ; ++i) {
        printf("%u\n", (unsigned)v[i]);
    }
#endif

 out:

    /* Handle exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (prng) {
        cgul_random_lfg32__delete(prng);
    }
    if (v) {
        free(v);
    }

    return rv;
}
