#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_string_t s1 = NULL;
    cgul_string_t s2 = NULL;
    cgul_exception_t local = NULL;

    /* Allocate. */
    s1 = cgul_string__new_from_cstring(&local, "Hello, World!");
    s2 = cgul_string__new_from_cstring(&local, "Goodbye, Cruel World!");
    if (local) {
        goto out;
    }

    printf("s1 = %s\n", cgul_string__get_value(&local, s1));
    printf("s2 = %s\n", cgul_string__get_value(&local, s2));

    cgul_string__swap(&local, s1, s2);

    printf("s1 = %s\n", cgul_string__get_value(&local, s1));
    printf("s2 = %s\n", cgul_string__get_value(&local, s2));

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (s2) {
        cgul_string__delete(s2);
    }
    if (s1) {
        cgul_string__delete(s1);
    }

    return rv;
}
