#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    size_t utf8_char_count = 0;
    char buf[CGUL_WCHAR__MB_LEN_MAX + 1];
    cgul_string_t s = NULL;
    cgul_exception_t local = NULL;

    /* Allocate a UTF-8 string. */
    s = cgul_string__new(&local);

    /* Convert UTF-32 BOM to UTF-8 BOM. */
    cgul_unicode__wctomb(&local, CGUL_WCHAR__BOM, buf);

    /* Append the UTF-8 BOM to s so we can test the "skip_bom" feature. */
    cgul_string__append(&local, s, buf);

    /* Append the rest of the string. */
    cgul_string__append(&local, s, "Hello");

    /* Count the number of UTF-8 characters. */
    utf8_char_count =
        cgul_unicode__get_char_count(&local,
                                     cgul_string__get_value(&local, s),
                                     cgul_string__get_length(&local, s),
                                     1 /* skip_bom */);

    /* Print the character count. */
    cgul_libc__printf(&local,
                      "utf8_char_count = %lu\n",
                      (unsigned long int)utf8_char_count);

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (s) {
        cgul_string__delete(s);
    }

    return rv;
}
